Codeforces 734C. Anton and Making Potions

来源:互联网 发布:淘宝数据分析表格 编辑:程序博客网 时间:2024/05/16 15:15

C. Anton and Making Potions
time limit per test4 seconds
memory limit per test256 megabytes
inputstandard input
outputstandard output
Anton is playing a very interesting computer game, but now he is stuck at one of the levels. To pass to the next level he has to prepare n potions.
Anton has a special kettle, that can prepare one potions in x seconds. Also, he knows spells of two types that can faster the process of preparing potions.
Spells of this type speed up the preparation time of one potion. There are m spells of this type, the i-th of them costs bi manapoints and changes the preparation time of each potion to ai instead of x.
Spells of this type immediately prepare some number of potions. There are k such spells, the i-th of them costs di manapoints and instantly create ci potions.
Anton can use no more than one spell of the first type and no more than one spell of the second type, and the total number of manapoints spent should not exceed s. Consider that all spells are used instantly and right before Anton starts to prepare potions.
Anton wants to get to the next level as fast as possible, so he is interested in the minimum number of time he needs to spent in order to prepare at least n potions.
Input
The first line of the input contains three integers n, m, k (1 ≤ n ≤ 2·109, 1 ≤ m, k ≤ 2·105) — the number of potions, Anton has to make, the number of spells of the first type and the number of spells of the second type.
The second line of the input contains two integers x and s (2 ≤ x ≤ 2·109, 1 ≤ s ≤ 2·109) — the initial number of seconds required to prepare one potion and the number of manapoints Anton can use.
The third line contains m integers ai (1 ≤ ai < x) — the number of seconds it will take to prepare one potion if the i-th spell of the first type is used.
The fourth line contains m integers bi (1 ≤ bi ≤ 2·109) — the number of manapoints to use the i-th spell of the first type.
There are k integers ci (1 ≤ ci ≤ n) in the fifth line — the number of potions that will be immediately created if the i-th spell of the second type is used. It’s guaranteed that ci are not decreasing, i.e. ci ≤ cj if i < j.
The sixth line contains k integers di (1 ≤ di ≤ 2·109) — the number of manapoints required to use the i-th spell of the second type. It’s guaranteed that di are not decreasing, i.e. di ≤ dj if i < j.
Output
Print one integer — the minimum time one has to spent in order to prepare n potions.
Examples
Input
20 3 2
10 99
2 4 3
20 10 40
4 15
10 80
Output
20
Input
20 3 2
10 99
2 4 3
200 100 400
4 15
100 800
Output
200

思路:题目长的可怕,但是思路很清楚,暴力穷举哪个第一种药水,然后二分查找到d中满足剩下的s是够得且消掉的药水数最大,二分查找就行了(注意他们都可以不用,所以要加上初始状态!)看代码很直接

(弱居然二分都写不好一直TLE…)

#include<bits/stdc++.h>#define input freopen("input.txt","r",stdin)using namespace std;__int64 a[200005],b[200005],c[200005],d[200005],pos;void search(int l,int r,__int64 value){    if(l>r) return ;    if(l==r){        if(value>=d[l]){            pos=l;        }         return ;    }    int mid=(l+r)/2;    if(value>=d[mid]){        pos=mid;        search(mid+1,r,value);    }    else{        search(l,mid-1,value);    }    return ;}int main(){    __int64 s,x,n,m,k;    int i,j;    while(scanf("%I64d%I64d%I64d",&n,&m,&k)!=EOF){        scanf("%I64d%I64d",&x,&s);        for(i=1;i<=m;i++) scanf("%I64d",&a[i]);        for(i=1;i<=m;i++) scanf("%I64d",&b[i]);        for(i=1;i<=k;i++) scanf("%I64d",&c[i]);        for(i=1;i<=k;i++) scanf("%I64d",&d[i]);        a[0]=x; b[0]=0;  //代表不替换         c[0]=0; d[0]=0;  //代表立刻消掉一个,花费为0,相当于不选         __int64 ans=n*x;        for(i=0;i<=m;i++){  //暴力跑然后二分查找匹配的最优解,因为cd都是排好序的,可以直接用!很关键             __int64 money=s-b[i];            if(money<0) continue;            pos=0;            search(0,k,money);            ans=ans<((n-c[pos])*a[i])?ans:((n-c[pos])*a[i]);        }        printf("%I64d\n",ans);    }    return 0;}
0 0